jif.parse

## Class Lexer_c

- java.lang.Object
- - jif.parse.Lexer_c

- All Implemented Interfaces:
    polyglot.lex.Lexer

      public class Lexer_c
      extends java.lang.Object
      implements polyglot.lex.Lexer

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CHARACTER`
    `static int` | `END_OF_LINE_COMMENT`
    `static int` | `JAVADOC_COMMENT`
    `static int` | `STRING`
    `static int` | `TRADITIONAL_COMMENT`
    `static int` | `YYEOF` This character denotes the end of file
    `static int` | `YYINITIAL` lexical states

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Lexer_c(java.io.InputStream in, polyglot.frontend.Source file, polyglot.util.ErrorQueue eq)`
    `Lexer_c(java.io.Reader in)` Creates a new scanner
    `Lexer_c(java.io.Reader reader, polyglot.frontend.Source file, polyglot.util.ErrorQueue eq)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `file()`
    `protected void` | `init_keywords()`
    `java.util.Set<java.lang.String>` | `keywords()`
    `polyglot.lex.Token` | `nextToken()` Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
    `java.lang.String` | `path()`
    `void` | `yybegin(int newState)` Enters a new lexical state
    `char` | `yycharat(int pos)` Returns the character at position `pos` from the matched text.
    `void` | `yyclose()` Closes the input stream.
    `int` | `yylength()` Returns the length of the matched text region.
    `void` | `yypushback(int number)` Pushes the specified amount of characters back into the input stream.
    `void` | `yyreset(java.io.Reader reader)` Resets the scanner to read from a new input stream.
    `int` | `yystate()` Returns the current lexical state.
    `java.lang.String` | `yytext()` Returns the text matched by the current regular expression.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### YYEOF

          public static final int YYEOF

      This character denotes the end of file
      See Also:
        Constant Field Values

    - #### YYINITIAL

          public static final int YYINITIAL

      lexical states
      See Also:
        Constant Field Values

    - #### STRING

          public static final int STRING

      See Also:
        Constant Field Values

    - #### CHARACTER

          public static final int CHARACTER

      See Also:
        Constant Field Values

    - #### TRADITIONAL_COMMENT

          public static final int TRADITIONAL_COMMENT

      See Also:
        Constant Field Values

    - #### END_OF_LINE_COMMENT

          public static final int END_OF_LINE_COMMENT

      See Also:
        Constant Field Values

    - #### JAVADOC_COMMENT

          public static final int JAVADOC_COMMENT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Lexer_c

          public Lexer_c(java.io.InputStream in,
                         polyglot.frontend.Source file,
                         polyglot.util.ErrorQueue eq)

    - #### Lexer_c

          public Lexer_c(java.io.Reader reader,
                         polyglot.frontend.Source file,
                         polyglot.util.ErrorQueue eq)

    - #### Lexer_c

          public Lexer_c(java.io.Reader in)

      Creates a new scanner
      Parameters:
        `in` - the java.io.Reader to read input from.

  - ### Method Detail

    - #### keywords

          public java.util.Set<java.lang.String> keywords()

      Specified by:
        `keywords` in interface `polyglot.lex.Lexer`

    - #### init_keywords

          protected void init_keywords()

    - #### file

          public java.lang.String file()

      Specified by:
        `file` in interface `polyglot.lex.Lexer`

    - #### path

          public java.lang.String path()

      Specified by:
        `path` in interface `polyglot.lex.Lexer`

    - #### yyclose

          public final void yyclose()
                             throws java.io.IOException

      Closes the input stream.
      Throws:
        `java.io.IOException`

    - #### yyreset

          public final void yyreset(java.io.Reader reader)

      Resets the scanner to read from a new input stream. Does not close the old reader. All internal variables are reset, the old input stream cannot be reused (internal buffer is discarded and lost). Lexical state is set to `ZZ_INITIAL`. Internal scan buffer is resized down to its initial length, if it has grown.
      Parameters:
        `reader` - the new input stream

    - #### yystate

          public final int yystate()

      Returns the current lexical state.

    - #### yybegin

          public final void yybegin(int newState)

      Enters a new lexical state
      Parameters:
        `newState` - the new lexical state

    - #### yytext

          public final java.lang.String yytext()

      Returns the text matched by the current regular expression.

    - #### yycharat

          public final char yycharat(int pos)

      Returns the character at position `pos` from the matched text. It is equivalent to yytext().charAt(pos), but faster
      Parameters:
        `pos` - the position of the character to fetch. A value from 0 to yylength()-1.
      Returns:
        the character at position pos

    - #### yylength

          public final int yylength()

      Returns the length of the matched text region.

    - #### yypushback

          public void yypushback(int number)

      Pushes the specified amount of characters back into the input stream. They will be read again by then next call of the scanning method
      Parameters:
        `number` - the number of characters to be read again. This number must not be greater than yylength()!

    - #### nextToken

          public polyglot.lex.Token nextToken()
                                       throws java.io.IOException

      Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
      Specified by:
        `nextToken` in interface `polyglot.lex.Lexer`
      Returns:
        the next token
      Throws:
        `java.io.IOException` - if any I/O-Error occurs